# encoding: utf-8

require 'oauth'
require 'fanfou'

require 'sinatra' # install via gem install sinatra
require 'sinatra/cookies' # install via gem install sinatra-contrib

set :fanfou_consumer_key, ""     # set your consumer key here
set :fanfou_consumer_secret, ""  # set your consumer secret here

before do
  @fanfou_client = Fanfou::Fanfou.new(settings.fanfou_consumer_key,
                                      settings.fanfou_consumer_secret)
  # cookies.options.delete(:domain) # dirty hack for cookie error.. if you got 401 Unauthorized, you can try to enable this.
end

get '/' do
  '<a href="/oauth">Click here to login with fanfou</a>'
end

get '/oauth' do
  redirect_url = @fanfou_client.get_authorize_url
  cookies[:request_token] = @fanfou_client.request_token.token
  cookies[:request_token_secret] = @fanfou_client.request_token.secret
  puts @fanfou_client.request_token.token
  redirect redirect_url
end

get '/callback' do
  @fanfou_client.get_access_token(cookies[:request_token], cookies[:request_token_secret], params[:oauth_token])
  cookies[:request_token] = nil
  cookies[:request_token_secret] = nil
  result = @fanfou_client.fanfou_request("/account/verify_credentials")
  "token: #{@fanfou_client.access_token.token}\n secret: #{@fanfou_client.access_token.secret}\n #{result.to_s}"
end
